Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");


/**
 * Utility stuff to pass params to main.js which will handle them.
 */
var startPoint="youtubemusicplayer.";

var pref=Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefService).
    getBranch(startPoint); 
 
function setPref(prefName, value)
{
	pref.setBoolPref(prefName, value);
}

function commandLine() {
}
commandLine.prototype = {
  classDescription: "Command Line for YMP",
  // this must match whatever is in chrome.manifest!
  classID: Components.ID("{32bd6750-54cc-11e0-b8af-0800200c9a66}"),

  // [optional] an array of categories to register this component in.
  _xpcom_categories: [{
    // Each object in the array specifies the parameters to pass to
    // nsICategoryManager.addCategoryEntry(). 'true' is passed for
    // both aPersist and aReplace params.
    category: "command-line-handler",
    // optional, defaults to the object's classDescription
    entry: "m-ymp",
    // optional, defaults to the object's contractID (unless
    // 'service' is specified)
    value: "@ym-player.de/ymp/clh;1"
  }],

  QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsICommandLineHandler]),

  contractID: "@ym-player.de/ymp/clh;1",
  
  /* nsICommandLineHandler */

  handle : function clh_handle(cmdLine)
  {
	//TODO: SIMPLIFY
    //if a command line is set set the preference so main.js can handle it ;)
    if (cmdLine.handleFlag("music", false))
      setPref("startonload", true);
	else
      setPref("startonload", false);
	
    if (cmdLine.handleFlag("play", false))
      setPref("playcmd", true);
	else
      setPref("playcmd", false);

    if (cmdLine.handleFlag("pause", false))
      setPref("pausecmd", true);
	else
      setPref("pausecmd", false);
	  
    if (cmdLine.handleFlag("next", false))
      setPref("nextcmd", true);
	else
      setPref("nextcmd", false);
	  
    if (cmdLine.handleFlag("toggle", false))
      setPref("togglecmd", true);
	else
      setPref("togglecmd", false);	  
	  
    if (cmdLine.handleFlag("tmute", false))
      setPref("tmutecmd", true);
	else
      setPref("tmutecmd", false);	  
	  
    if (cmdLine.handleFlag("tfs", false))
      setPref("tfscmd", true);
	else
      setPref("tfscmd", false);
  },

  helpInfo : "  -music               Start Playback\n",  
};

/**
* XPCOMUtils.generateNSGetFactory was introduced in Mozilla 2 (Firefox 4).
* XPCOMUtils.generateNSGetModule is for Mozilla 1.9.2 (Firefox 3.6).
*/
if (XPCOMUtils.generateNSGetFactory) 
	var NSGetFactory = XPCOMUtils.generateNSGetFactory([commandLine]);
else {
	var NSGetModule = XPCOMUtils.generateNSGetModule([commandLine]);
}